/**************************************************************************

	slave.c

   Z-World, 2001
	This sample program is for the BL2100 series controllers.

	Connect circuitry as	described in the User Manual in the main
	hardware chapter under Serial Communication.
	
	This program demonstrates a simple RS485 transmission
	of alpha characters to a master controller.  The slave
	will send back converted upper case letters back to the
	master controller and displayed in STDIO window.
	
	Use master.c to program the master controller.
		
	Make the following connections:

		Master to  Slave
		485+ <---> 485+							
		485- <---> 485-							
		GND  <---> GND

**************************************************************************/

// serial D buffer size
#define DINBUFSIZE  255
#define DOUTBUFSIZE 255


void msdelay (long sd)
{
	unsigned long t1;

	t1=MS_TIMER;
	for (t1=MS_TIMER; MS_TIMER<(sd+t1); );
}

///////////////////////////////////////////////////////////////////////////
main()
{
	auto int nIn1;
	auto char cOut;

	brdInit();				//required for BL2100 series boards

	serDopen(19200);		//set baud rate first
	serDwrFlush();			//clear Rx and Tx data buffers
	serDrdFlush();

	serMode(0);
	
	while (1)
	{
		while ((nIn1 = serDgetc()) == -1);	//	wait for lowercase ascii byte
		ser485Tx();									//	enable transmitter
		serDputc ( toupper(nIn1) );			//	echo uppercase byte
		while (serDgetc() == -1);				//	wait for echo
		ser485Rx();									//	disable transmitter
	}
}
///////////////////////////////////////////////////////////////////////////
